/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute( ExternalCommandData revit, ref string message, ElementSet elements) { m_commandData = revit; if (!PreData()) { message = "Please select only one AreaReinforcement and "; message += "make sure there are Hook Types and Bar Types in current project."; return(Autodesk.Revit.UI.Result.Failed); } IAreaReinData data = new WallAreaReinData(); if (!data.FillInData(m_areaRein)) { data = new FloorAreaReinData(); if (!data.FillInData(m_areaRein)) { message = "Failed to get properties of selected AreaReinforcement."; return(Autodesk.Revit.UI.Result.Failed); } } AreaReinParametersForm form = new AreaReinParametersForm(data); if (form.ShowDialog() == DialogResult.Cancel) { return(Autodesk.Revit.UI.Result.Cancelled); } return(Autodesk.Revit.UI.Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute( ExternalCommandData revit, ref string message, ElementSet elements) { Transaction trans = new Transaction(revit.Application.ActiveUIDocument.Document, "Revit.SDK.Samples.AreaReinParameters"); trans.Start(); m_commandData = revit; if (!PreData()) { message = "Please select only one AreaReinforcement and "; message += "make sure there are Hook Types and Bar Types in current project."; trans.RollBack(); return(Autodesk.Revit.UI.Result.Failed); } IAreaReinData data = new WallAreaReinData(); if (!data.FillInData(m_areaRein)) { data = new FloorAreaReinData(); if (!data.FillInData(m_areaRein)) { message = "Failed to get properties of selected AreaReinforcement."; trans.RollBack(); return(Autodesk.Revit.UI.Result.Failed); } } AreaReinParametersForm form = new AreaReinParametersForm(data); if (form.ShowDialog() == DialogResult.Cancel) { trans.RollBack(); return(Autodesk.Revit.UI.Result.Cancelled); } trans.Commit(); return(Autodesk.Revit.UI.Result.Succeeded); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute( ExternalCommandData revit, ref string message, ElementSet elements ) { m_commandData = revit; if( !PreData() ) { message = "Please select only one AreaReinforcement and "; message += "make sure there are Hook Types and Bar Types in current project."; return Autodesk.Revit.UI.Result.Failed; } IAreaReinData data = new WallAreaReinData(); if( !data.FillInData( m_areaRein ) ) { data = new FloorAreaReinData(); if( !data.FillInData( m_areaRein ) ) { message = "Failed to get properties of selected AreaReinforcement."; return Autodesk.Revit.UI.Result.Failed; } } AreaReinParametersForm form = new AreaReinParametersForm( data ); if( form.ShowDialog() == DialogResult.Cancel ) { return Autodesk.Revit.UI.Result.Cancelled; } return Autodesk.Revit.UI.Result.Succeeded; }